Index: uspace/app/taskdump/elf_core.c
===================================================================
--- uspace/app/taskdump/elf_core.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/taskdump/elf_core.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -54,7 +54,5 @@
 #include <errno.h>
 #include <sys/types.h>
-#include <sys/stat.h>
 #include <unistd.h>
-#include <fcntl.h>
 #include <mem.h>
 #include <stdint.h>
@@ -63,10 +61,10 @@
 #include <macros.h>
 #include <libarch/istate.h>
+#include <vfs/vfs.h>
 
 #include "elf_core.h"
 
 static off64_t align_foff_up(off64_t, uintptr_t, size_t);
-static int align_pos(int, size_t);
-static int write_mem_area(int, as_area_info_t *, async_sess_t *);
+static int write_mem_area(int, aoff64_t *, as_area_info_t *, async_sess_t *);
 
 #define BUFFER_SIZE 0x1000
@@ -97,4 +95,5 @@
 	elf_note_t note;
 	size_t word_size;
+	aoff64_t pos = 0;
 
 	int fd;
@@ -124,5 +123,6 @@
 	}
 
-	fd = open(file_name, O_CREAT | O_WRONLY, 0644);
+	fd = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_WRITE);
 	if (fd < 0) {
 		printf("Failed opening file.\n");
@@ -207,5 +207,5 @@
 	}
 
-	rc = write(fd, &elf_hdr, sizeof(elf_hdr));
+	rc = vfs_write(fd, &pos, &elf_hdr, sizeof(elf_hdr));
 	if (rc != sizeof(elf_hdr)) {
 		printf("Failed writing ELF header.\n");
@@ -215,5 +215,5 @@
 
 	for (i = 0; i < n_ph; ++i) {
-		rc = write(fd, &p_hdr[i], sizeof(p_hdr[i]));
+		rc = vfs_write(fd, &pos, &p_hdr[i], sizeof(p_hdr[i]));
 		if (rc != sizeof(p_hdr[i])) {
 			printf("Failed writing program header.\n");
@@ -223,9 +223,5 @@
 	}
 
-	if (lseek(fd, p_hdr[0].p_offset, SEEK_SET) == (off64_t) -1) {
-		printf("Failed writing memory data.\n");
-		free(p_hdr);
-		return EIO;
-	}
+	pos = p_hdr[0].p_offset;
 
 	/*
@@ -236,5 +232,5 @@
 	note.type = NT_PRSTATUS;
 
-	rc = write(fd, &note, sizeof(elf_note_t));
+	rc = vfs_write(fd, &pos, &note, sizeof(elf_note_t));
 	if (rc != sizeof(elf_note_t)) {
 		printf("Failed writing note header.\n");
@@ -243,5 +239,5 @@
 	}
 
-	rc = write(fd, "CORE", note.namesz);
+	rc = vfs_write(fd, &pos, "CORE", note.namesz);
 	if (rc != (ssize_t) note.namesz) {
 		printf("Failed writing note header.\n");
@@ -250,12 +246,7 @@
 	}
 
-	rc = align_pos(fd, word_size);
-	if (rc != EOK) {
-		printf("Failed writing note header.\n");
-		free(p_hdr);
-		return EIO;
-	}
-
-	rc = write(fd, &pr_status, sizeof(elf_prstatus_t));
+	pos = ALIGN_UP(pos, word_size);
+
+	rc = vfs_write(fd, &pos, &pr_status, sizeof(elf_prstatus_t));
 	if (rc != sizeof(elf_prstatus_t)) {
 		printf("Failed writing register data.\n");
@@ -265,10 +256,6 @@
 
 	for (i = 1; i < n_ph; ++i) {
-		if (lseek(fd, p_hdr[i].p_offset, SEEK_SET) == (off64_t) -1) {
-			printf("Failed writing memory data.\n");
-			free(p_hdr);
-			return EIO;
-		}
-		if (write_mem_area(fd, &ainfo[i - 1], sess) != EOK) {
+		pos = p_hdr[i].p_offset;
+		if (write_mem_area(fd, &pos, &ainfo[i - 1], sess) != EOK) {
 			printf("Failed writing memory data.\n");
 			free(p_hdr);
@@ -297,4 +284,5 @@
  *
  * @param fd   File to write to.
+ * @param pos  Pointer to the position to write to.
  * @param area Memory area info structure.
  * @param sess Debugging session.
@@ -303,5 +291,6 @@
  *
  */
-static int write_mem_area(int fd, as_area_info_t *area, async_sess_t *sess)
+static int write_mem_area(int fd, aoff64_t *pos, as_area_info_t *area,
+    async_sess_t *sess)
 {
 	size_t to_copy;
@@ -321,5 +310,5 @@
 		}
 
-		rc = write(fd, buffer, to_copy);
+		rc = vfs_write(fd, pos, buffer, to_copy);
 		if (rc != (ssize_t) to_copy) {
 			printf("Failed writing memory contents.\n");
@@ -334,23 +323,4 @@
 }
 
-static int align_pos(int fd, size_t align)
-{
-	off64_t cur_pos;
-	size_t rem, adv;
-
-	cur_pos = lseek(fd, 0, SEEK_CUR);
-	if (cur_pos < 0)
-		return -1;
-
-	rem = cur_pos % align;
-	adv = align - rem;
-
-	cur_pos = lseek(fd, adv, SEEK_CUR);
-	if (cur_pos < 0)
-		return -1;
-
-	return EOK;
-}
-
 /** @}
  */
Index: uspace/app/taskdump/symtab.c
===================================================================
--- uspace/app/taskdump/symtab.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/taskdump/symtab.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,6 +41,5 @@
 #include <errno.h>
 #include <sys/types.h>
-#include <sys/stat.h>
-#include <fcntl.h>
+#include <vfs/vfs.h>
 
 #include "include/symtab.h"
@@ -68,4 +67,5 @@
 	char *shstrt, *sec_name;
 	void *data;
+	aoff64_t pos = 0;
 
 	int fd;
@@ -81,5 +81,5 @@
 		return ENOMEM;
 
-	fd = open(file_name, O_RDONLY);
+	fd = vfs_lookup_open(file_name, WALK_REGULAR, MODE_READ);
 	if (fd < 0) {
 		printf("failed opening file\n");
@@ -88,5 +88,5 @@
 	}
 
-	rc = read(fd, &elf_hdr, sizeof(elf_header_t));
+	rc = vfs_read(fd, &pos, &elf_hdr, sizeof(elf_header_t));
 	if (rc != sizeof(elf_header_t)) {
 		printf("failed reading elf header\n");
@@ -165,5 +165,5 @@
 
 	free(shstrt);
-	close(fd);
+	vfs_put(fd);
 
 	if (stab->sym == NULL || stab->strtab == NULL) {
@@ -304,11 +304,7 @@
 {
 	int rc;
-
-	rc = lseek(fd, elf_hdr->e_shoff + idx * sizeof(elf_section_header_t),
-	    SEEK_SET);
-	if (rc == (off64_t) -1)
-		return EIO;
-
-	rc = read(fd, sec_hdr, sizeof(elf_section_header_t));
+	aoff64_t pos = elf_hdr->e_shoff + idx * sizeof(elf_section_header_t);
+
+	rc = vfs_read(fd, &pos, sec_hdr, sizeof(elf_section_header_t));
 	if (rc != sizeof(elf_section_header_t))
 		return EIO;
@@ -331,12 +327,5 @@
 {
 	ssize_t rc;
-	off64_t offs;
-
-	offs = lseek(fd, start, SEEK_SET);
-	if (offs == (off64_t) -1) {
-		printf("failed seeking chunk\n");
-		*ptr = NULL;
-		return EIO;
-	}
+	aoff64_t pos = start;
 
 	*ptr = malloc(size);
@@ -346,5 +335,5 @@
 	}
 
-	rc = read(fd, *ptr, size);
+	rc = vfs_read(fd, &pos, *ptr, size);
 	if (rc != (ssize_t) size) {
 		printf("failed reading chunk\n");
Index: uspace/app/tester/hw/misc/virtchar1.c
===================================================================
--- uspace/app/tester/hw/misc/virtchar1.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/tester/hw/misc/virtchar1.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,6 +45,4 @@
 #include <vfs/vfs.h>
 #include <vfs/vfs_sess.h>
-#include <sys/stat.h>
-#include <fcntl.h>
 #include "../../tester.h"
 
@@ -56,5 +54,5 @@
 {
 	TPRINTF("Opening `%s'...\n", path);
-	int fd = open(path, O_RDONLY);
+	int fd = vfs_lookup(path, WALK_REGULAR);
 	if (fd < 0) {
 		TPRINTF("   ...error: %s\n", str_error(errno));
@@ -71,5 +69,5 @@
 	async_sess_t *sess = vfs_fd_session(fd, INTERFACE_DDF);
 	if (!sess) {
-		close(fd);
+		vfs_put(fd);
 		TPRINTF("   ...error: %s\n", str_error(errno));
 		return "Failed to get session to device";
@@ -92,5 +90,5 @@
 	TPRINTF(" Closing session and file descriptor\n");
 	async_hangup(sess);
-	close(fd);
+	vfs_put(fd);
 	
 	return NULL;
Index: uspace/app/tester/mm/pager1.c
===================================================================
--- uspace/app/tester/mm/pager1.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/tester/mm/pager1.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -28,6 +28,5 @@
 
 #include <stdio.h>
-#include <unistd.h>
-#include <fcntl.h>
+#include <vfs/vfs.h>
 #include <stdlib.h>
 #include <malloc.h>
@@ -48,10 +47,12 @@
 	TPRINTF("Creating temporary file...\n");
 
-	fd = open(TEST_FILE, O_CREAT);
+	fd = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE);
 	if (fd < 0)
 		return NULL;
-	(void) unlink(TEST_FILE);
-	if (write(fd, text, sizeof(text)) != sizeof(text)) {
-		close(fd);
+	(void) vfs_unlink_path(TEST_FILE);
+
+	if (vfs_write(fd, (aoff64_t []) {0}, text, sizeof(text)) < 0) {
+		vfs_put(fd);
 		return NULL;
 	}
@@ -64,5 +65,5 @@
 
 	if (!vfs_pager_sess) {
-		close(fd);
+		vfs_put(fd);
 		return NULL;
 	}
@@ -73,5 +74,5 @@
 	    AS_AREA_READ | AS_AREA_CACHEABLE, vfs_pager_sess, fd, 0, 0);
 	if (result == AS_MAP_FAILED) {
-		close(fd);
+		vfs_put(fd);
 		return NULL;
 	}
@@ -101,5 +102,5 @@
 
 	as_area_destroy(buffer);	
-	close(fd);
+	vfs_put(fd);
 	
 	return NULL;
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/tester/vfs/vfs1.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -33,9 +33,7 @@
 #include <vfs/vfs.h>
 #include <unistd.h>
-#include <fcntl.h>
 #include <dirent.h>
 #include <loc.h>
 #include <sys/types.h>
-#include <sys/stat.h>
 #include "../tester.h"
 
@@ -70,28 +68,31 @@
 const char *test_vfs1(void)
 {
-	if (mkdir(TEST_DIRECTORY, 0) != 0) {
-		TPRINTF("rc=%d\n", errno);
-		return "mkdir() failed";
+	aoff64_t pos = 0;
+	int rc;
+
+	rc = vfs_link_path(TEST_DIRECTORY, KIND_DIRECTORY, NULL);
+	if (rc != EOK) {
+		TPRINTF("rc=%d\n", rc);
+		return "vfs_link_path() failed";
 	}
 	TPRINTF("Created directory %s\n", TEST_DIRECTORY);
 	
-	int fd0 = open(TEST_FILE, O_CREAT);
+	int fd0 = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE);
 	if (fd0 < 0)
-		return "open() failed";
+		return "vfs_lookup_open() failed";
 	TPRINTF("Created file %s (fd=%d)\n", TEST_FILE, fd0);
 	
 	size_t size = sizeof(text);
-	ssize_t cnt = write(fd0, text, size);
+	ssize_t cnt = vfs_write(fd0, &pos, text, size);
 	if (cnt < 0)
 		return "write() failed";
 	TPRINTF("Written %zd bytes\n", cnt);
-	
-	if (lseek(fd0, 0, SEEK_SET) != 0)
-		return "lseek() failed";
-	TPRINTF("Sought to position 0\n");
+
+	pos = 0;
 	
 	char buf[BUF_SIZE];
 	TPRINTF("read..\n");
-	while ((cnt = read(fd0, buf, BUF_SIZE))) {
+	while ((cnt = vfs_read(fd0, &pos, buf, BUF_SIZE))) {
 		TPRINTF("read returns %zd\n", cnt);
 		if (cnt < 0)
@@ -107,5 +108,5 @@
 	}
 	
-	close(fd0);
+	vfs_put(fd0);
 	
 	const char *rv = read_root();
@@ -113,14 +114,14 @@
 		return rv;
 	
-	if (rename(TEST_FILE, TEST_FILE2) != 0)
-		return "rename() failed";
+	if (vfs_rename_path(TEST_FILE, TEST_FILE2) != EOK)
+		return "vfs_rename_path() failed";
 	TPRINTF("Renamed %s to %s\n", TEST_FILE, TEST_FILE2);
 	
-	if (unlink(TEST_FILE2) != 0)
-		return "unlink() failed";
+	if (vfs_unlink_path(TEST_FILE2) != EOK)
+		return "vfs_unlink_path() failed";
 	TPRINTF("Unlinked %s\n", TEST_FILE2);
 	
-	if (rmdir(TEST_DIRECTORY) != 0)
-		return "rmdir() failed";
+	if (vfs_unlink_path(TEST_DIRECTORY) != EOK)
+		return "vfs_unlink_path() failed";
 	TPRINTF("Removed directory %s\n", TEST_DIRECTORY);
 	
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/tetris/scores.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -65,5 +65,4 @@
 #include <vfs/vfs.h>
 #include <stdlib.h>
-#include <fcntl.h>
 #include <err.h>
 #include <time.h>
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/trace/trace.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -512,6 +512,6 @@
 		goto error;
 
-	/* Send program pathname */
-	rc = loader_set_pathname(ldr, path);
+	/* Send program. */
+	rc = loader_set_program_path(ldr, path);
 	if (rc != EOK)
 		goto error;
@@ -523,30 +523,35 @@
 
 	/* Send default files */
-	int *files[4];
+	int fd_root;
 	int fd_stdin;
 	int fd_stdout;
 	int fd_stderr;
 	
-	if ((stdin != NULL) && (vfs_fhandle(stdin, &fd_stdin) == EOK))
-		files[0] = &fd_stdin;
-	else
-		files[0] = NULL;
-	
-	if ((stdout != NULL) && (vfs_fhandle(stdout, &fd_stdout) == EOK))
-		files[1] = &fd_stdout;
-	else
-		files[1] = NULL;
-	
-	if ((stderr != NULL) && (vfs_fhandle(stderr, &fd_stderr) == EOK))
-		files[2] = &fd_stderr;
-	else
-		files[2] = NULL;
-	
-	files[3] = NULL;
-	
-	rc = loader_set_files(ldr, files);
-	if (rc != EOK)
-		goto error;
-
+	fd_root = vfs_root();
+	if (fd_root >= 0) {
+		rc = loader_add_inbox(ldr, "root", fd_root);
+		vfs_put(fd_root);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if ((stdin != NULL) && (vfs_fhandle(stdin, &fd_stdin) == EOK)) {
+		rc = loader_add_inbox(ldr, "stdin", fd_stdin);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if ((stdout != NULL) && (vfs_fhandle(stdout, &fd_stdout) == EOK)) {
+		rc = loader_add_inbox(ldr, "stdout", fd_stdout);
+		if (rc != EOK)
+			goto error;
+	}
+	
+	if ((stderr != NULL) && (vfs_fhandle(stderr, &fd_stderr) == EOK)) {
+		rc = loader_add_inbox(ldr, "stderr", fd_stderr);
+		if (rc != EOK)
+			goto error;
+	}
+	
 	/* Load the program. */
 	rc = loader_load_program(ldr);
@@ -696,34 +701,30 @@
 
 	p = proto_new("vfs");
-	o = oper_new("open", 2, arg_def, V_INT_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_OPEN, o);
-	o = oper_new("read", 1, arg_def, V_ERRNO, 1, resp_def);
+	o = oper_new("read", 3, arg_def, V_ERRNO, 1, resp_def);
 	proto_add_oper(p, VFS_IN_READ, o);
-	o = oper_new("write", 1, arg_def, V_ERRNO, 1, resp_def);
+	o = oper_new("write", 3, arg_def, V_ERRNO, 1, resp_def);
 	proto_add_oper(p, VFS_IN_WRITE, o);
-	o = oper_new("seek", 3, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_SEEK, o);
-	o = oper_new("truncate", 5, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_TRUNCATE, o);
-	o = oper_new("fstat", 1, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_FSTAT, o);
-	o = oper_new("close", 1, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_CLOSE, o);
-	o = oper_new("mount", 2, arg_def, V_ERRNO, 0, resp_def);
+	o = oper_new("vfs_resize", 5, arg_def, V_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_RESIZE, o);
+	o = oper_new("vfs_stat", 1, arg_def, V_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_STAT, o);
+	o = oper_new("vfs_put", 1, arg_def, V_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_PUT, o);
+	o = oper_new("vfs_mount", 2, arg_def, V_ERRNO, 0, resp_def);
 	proto_add_oper(p, VFS_IN_MOUNT, o);
 /*	o = oper_new("unmount", 0, arg_def);
 	proto_add_oper(p, VFS_IN_UNMOUNT, o);*/
-	o = oper_new("sync", 1, arg_def, V_ERRNO, 0, resp_def);
+	o = oper_new("vfs_sync", 1, arg_def, V_ERRNO, 0, resp_def);
 	proto_add_oper(p, VFS_IN_SYNC, o);
-	o = oper_new("mkdir", 1, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_MKDIR, o);
-	o = oper_new("unlink", 0, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_UNLINK, o);
 	o = oper_new("rename", 0, arg_def, V_ERRNO, 0, resp_def);
 	proto_add_oper(p, VFS_IN_RENAME, o);
-	o = oper_new("stat", 0, arg_def, V_ERRNO, 0, resp_def);
-	proto_add_oper(p, VFS_IN_STAT, o);
-	o = oper_new("statfs", 0, arg_def, V_ERRNO, 0, resp_def);
+	o = oper_new("vfs_statfs", 0, arg_def, V_ERRNO, 0, resp_def);
 	proto_add_oper(p, VFS_IN_STATFS, o);
+	o = oper_new("vfs_walk", 2, arg_def, V_INT_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_WALK, o);
+	o = oper_new("vfs_open", 2, arg_def, V_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_OPEN, o);
+	o = oper_new("vfs_unlink", 3, arg_def, V_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_UNLINK, o);
 
 	proto_register(SERVICE_VFS, p);
Index: uspace/app/untar/main.c
===================================================================
--- uspace/app/untar/main.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/untar/main.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -35,7 +35,7 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/stat.h>
 #include <errno.h>
 #include <str_error.h>
+#include <vfs/vfs.h>
 #include "tar.h"
 
@@ -103,9 +103,12 @@
 static int handle_directory(const tar_header_t *header, FILE *tarfile)
 {
-	if (mkdir(header->filename, 0755) != 0) {
-		if (errno != EEXIST) {
+	int rc;
+
+	rc = vfs_link_path(header->filename, KIND_DIRECTORY, NULL);
+	if (rc != EOK) {
+		if (rc != EEXIST) {
 			fprintf(stderr, "Failed to create directory %s: %s.\n",
-			    header->filename, str_error(errno));
-			return errno;
+			    header->filename, str_error(rc));
+			return rc;
 		}
 	}
Index: uspace/app/viewer/viewer.c
===================================================================
--- uspace/app/viewer/viewer.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/viewer/viewer.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -34,7 +34,6 @@
 
 #include <stdio.h>
-#include <unistd.h>
-#include <fcntl.h>
-#include <sys/stat.h>
+#include <stdlib.h>
+#include <vfs/vfs.h>
 #include <errno.h>
 #include <malloc.h>
@@ -110,12 +109,12 @@
 static bool img_load(const char *fname, surface_t **p_local_surface)
 {
-	int fd = open(fname, O_RDONLY);
+	int fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
 	if (fd < 0)
 		return false;
 	
 	struct stat stat;
-	int rc = fstat(fd, &stat);
-	if (rc != 0) {
-		close(fd);
+	int rc = vfs_stat(fd, &stat);
+	if (rc != EOK) {
+		vfs_put(fd);
 		return false;
 	}
@@ -123,16 +122,16 @@
 	void *tga = malloc(stat.size);
 	if (tga == NULL) {
-		close(fd);
-		return false;
-	}
-	
-	ssize_t rd = read(fd, tga, stat.size);
+		vfs_put(fd);
+		return false;
+	}
+
+	ssize_t rd = vfs_read(fd, (aoff64_t []) {0}, tga, stat.size);
 	if ((rd < 0) || (rd != (ssize_t) stat.size)) {
 		free(tga);
-		close(fd);
-		return false;
-	}
-	
-	close(fd);
+		vfs_put(fd);
+		return false;
+	}
+	
+	vfs_put(fd);
 	
 	*p_local_surface = decode_tga(tga, stat.size, 0);
Index: uspace/app/websrv/websrv.c
===================================================================
--- uspace/app/websrv/websrv.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/app/websrv/websrv.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -39,8 +39,8 @@
 #include <stdio.h>
 #include <sys/types.h>
-#include <sys/stat.h>
 #include <stdlib.h>
-#include <fcntl.h>
 #include <task.h>
+
+#include <vfs/vfs.h>
 
 #include <inet/addr.h>
@@ -225,5 +225,5 @@
 		return ENOMEM;
 	
-	int fd = open(fname, O_RDONLY);
+	int fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
 	if (fd < 0) {
 		rc = send_response(conn, msg_not_found);
@@ -238,11 +238,12 @@
 		return rc;
 	
+	aoff64_t pos = 0;
 	while (true) {
-		ssize_t nr = read(fd, fbuf, BUFFER_SIZE);
+		ssize_t nr = vfs_read(fd, &pos, fbuf, BUFFER_SIZE);
 		if (nr == 0)
 			break;
 		
 		if (nr < 0) {
-			close(fd);
+			vfs_put(fd);
 			return EIO;
 		}
@@ -251,10 +252,10 @@
 		if (rc != EOK) {
 			fprintf(stderr, "tcp_conn_send() failed\n");
-			close(fd);
+			vfs_put(fd);
 			return rc;
 		}
 	}
 	
-	close(fd);
+	vfs_put(fd);
 	
 	return EOK;
Index: uspace/drv/bus/isa/isa.c
===================================================================
--- uspace/drv/bus/isa/isa.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/drv/bus/isa/isa.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -51,8 +51,7 @@
 #include <malloc.h>
 #include <dirent.h>
-#include <fcntl.h>
 #include <ipc/irc.h>
 #include <ipc/services.h>
-#include <sys/stat.h>
+#include <vfs/vfs.h>
 #include <irc.h>
 #include <ns.h>
@@ -254,6 +253,7 @@
 	size_t len;
 	ssize_t r;
-
-	fd = open(conf_path, O_RDONLY);
+	struct stat st;
+
+	fd = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ);
 	if (fd < 0) {
 		ddf_msg(LVL_ERROR, "Unable to open %s", conf_path);
@@ -263,6 +263,10 @@
 	opened = true;
 
-	len = lseek(fd, 0, SEEK_END);
-	lseek(fd, 0, SEEK_SET);
+	if (vfs_stat(fd, &st) != EOK) {
+		ddf_msg(LVL_ERROR, "Unable to vfs_stat %d", fd);
+		goto cleanup;
+	}
+
+	len = st.size;
 	if (len == 0) {
 		ddf_msg(LVL_ERROR, "Configuration file '%s' is empty.",
@@ -277,5 +281,5 @@
 	}
 
-	r = read(fd, buf, len);
+	r = vfs_read(fd, (aoff64_t []) {0}, buf, len);
 	if (r < 0) {
 		ddf_msg(LVL_ERROR, "Unable to read file '%s'.", conf_path);
@@ -294,5 +298,5 @@
 
 	if (opened)
-		close(fd);
+		vfs_put(fd);
 
 	return buf;
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/drv/char/ns8250/ns8250.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -48,6 +48,4 @@
 #include <malloc.h>
 #include <dirent.h>
-#include <fcntl.h>
-#include <sys/stat.h>
 #include <ddi.h>
 
Index: uspace/lib/bithenge/src/failure.c
===================================================================
--- uspace/lib/bithenge/src/failure.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/bithenge/src/failure.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,5 +41,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/stat.h>
 #include <sys/types.h>
 #include <sys/wait.h>
@@ -152,7 +151,7 @@
 		if (null == -1)
 			exit(127);
-		dup2(null, STDOUT_FILENO);
-		dup2(null, STDERR_FILENO);
-		close(null);
+		vfs_clone(null, STDOUT_FILENO, false);
+		vfs_clone(null, STDERR_FILENO, false);
+		vfs_put(null);
 		return 1;
 	}
Index: uspace/lib/bithenge/src/failure.h
===================================================================
--- uspace/lib/bithenge/src/failure.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/bithenge/src/failure.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -42,5 +42,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/stat.h>
 #include <sys/types.h>
 #include <unistd.h>
Index: uspace/lib/bithenge/src/file.c
===================================================================
--- uspace/lib/bithenge/src/file.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/bithenge/src/file.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,8 +38,7 @@
 #include <assert.h>
 #include <errno.h>
-#include <fcntl.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/stat.h>
+#include <vfs/vfs.h>
 #include <sys/types.h>
 #include <unistd.h>
@@ -78,18 +77,9 @@
 	if (offset > blob->size)
 		return ELIMIT;
-	if (lseek(blob->fd, offset, SEEK_SET) < 0)
-		return errno == EINVAL ? EIO : errno;
 
-	ssize_t amount_read;
-	aoff64_t remaining_size = *size;
-	*size = 0;
-	do {
-		amount_read = read(blob->fd, buffer, remaining_size);
-		if (amount_read < 0)
-			return errno;
-		buffer += amount_read;
-		*size += amount_read;
-		remaining_size -= amount_read;
-	} while (remaining_size && amount_read);
+	ssize_t amount_read = vfs_read(blob->fd, &offset, buffer, *size);
+	if (amount_read < 0)
+		return errno;
+	*size += amount_read;
 	return EOK;
 }
@@ -98,5 +88,5 @@
 {
 	file_blob_t *blob = blob_as_file(base);
-	close(blob->fd);
+	vfs_put(blob->fd);
 	free(blob);
 }
@@ -113,8 +103,8 @@
 
 	struct stat stat;
-	int rc = fstat(fd, &stat);
-	if (rc != 0) {
+	int rc = vfs_stat(fd, &stat);
+	if (rc != EOK) {
 		if (needs_close)
-			close(fd);
+			vfs_put(fd);
 		return rc;
 	}
@@ -124,5 +114,5 @@
 	if (!blob) {
 		if (needs_close)
-			close(fd);
+			vfs_put(fd);
 		return ENOMEM;
 	}
@@ -131,5 +121,5 @@
 		free(blob);
 		if (needs_close)
-			close(fd);
+			vfs_put(fd);
 		return rc;
 	}
@@ -155,5 +145,5 @@
 	assert(filename);
 
-	int fd = open(filename, O_RDONLY);
+	int fd = vfs_lookup_open(filename, WALK_REGULAR, MODE_READ);
 	if (fd < 0)
 		return errno;
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/Makefile	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -73,4 +73,5 @@
 	generic/device/clock_dev.c \
 	generic/device/led_dev.c \
+	generic/dirent.c \
 	generic/dhcp.c \
 	generic/dnsr.c \
@@ -147,6 +148,8 @@
 	generic/stdlib.c \
 	generic/udebug.c \
+	generic/vfs/canonify.c \
+	generic/vfs/inbox.c \
+	generic/vfs/mtab.c \
 	generic/vfs/vfs.c \
-	generic/vfs/canonify.c \
 	generic/rcu.c \
 	generic/setjmp.c \
Index: uspace/lib/c/generic/dirent.c
===================================================================
--- uspace/lib/c/generic/dirent.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
+++ uspace/lib/c/generic/dirent.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -0,0 +1,125 @@
+/*
+ * Copyright (c) 2008 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <vfs/vfs.h>
+#include <stdlib.h>
+#include <dirent.h>
+#include <sys/types.h>
+#include <errno.h>
+#include <assert.h>
+
+/** Open directory.
+ *
+ * @param dirname Directory pathname
+ *
+ * @return Non-NULL pointer on success. On error returns @c NULL and sets errno.
+ */
+DIR *opendir(const char *dirname)
+{
+	DIR *dirp = malloc(sizeof(DIR));
+	if (!dirp) {
+		errno = ENOMEM;
+		return NULL;
+	}
+	
+	int fd = vfs_lookup(dirname, WALK_DIRECTORY);
+	if (fd < 0) {
+		free(dirp);
+		errno = fd;
+		return NULL;
+	}
+	
+	int rc = vfs_open(fd, MODE_READ);
+	if (rc < 0) {
+		free(dirp);
+		vfs_put(fd);
+		errno = rc;
+		return NULL;
+	}
+	
+	dirp->fd = fd;
+	dirp->pos = 0;
+	return dirp;
+}
+
+/** Read directory entry.
+ *
+ * @param dirp Open directory
+ * @return Non-NULL pointer to directory entry on success. On error returns
+ *         @c NULL and sets errno.
+ */
+struct dirent *readdir(DIR *dirp)
+{
+	int rc;
+	ssize_t len = 0;
+	
+	rc = vfs_read_short(dirp->fd, dirp->pos, &dirp->res.d_name[0],
+	    NAME_MAX + 1, &len);
+	if (rc != EOK) {
+		errno = rc;
+		return NULL;
+	}
+	
+	dirp->pos += len;
+	
+	return &dirp->res;
+}
+
+/** Rewind directory position to the beginning.
+ *
+ * @param dirp Open directory
+ */
+void rewinddir(DIR *dirp)
+{
+	dirp->pos = 0;
+}
+
+/** Close directory.
+ *
+ * @param dirp Open directory
+ * @return 0 on success. On error returns -1 and sets errno.
+ */
+int closedir(DIR *dirp)
+{
+	int rc;
+	
+	rc = vfs_put(dirp->fd);
+	free(dirp);
+
+	/* On error errno was set by close() */
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/elf/elf_load.c
===================================================================
--- uspace/lib/c/generic/elf/elf_load.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/elf/elf_load.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,4 +41,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <vfs/vfs.h>
 
 #ifdef CONFIG_RTLD
@@ -50,9 +51,9 @@
 /** Load ELF program.
  *
- * @param file_name File name
+ * @param file File handle 
  * @param info Place to store ELF program information
  * @return EOK on success or non-zero error code
  */
-int elf_load(const char *file_name, elf_info_t *info)
+int elf_load(int file, elf_info_t *info)
 {
 #ifdef CONFIG_RTLD
@@ -61,5 +62,5 @@
 	int rc;
 
-	rc = elf_load_file(file_name, 0, 0, &info->finfo);
+	rc = elf_load_file(file, 0, 0, &info->finfo);
 	if (rc != EE_OK) {
 		DPRINTF("Failed to load executable '%s'.\n", file_name);
Index: uspace/lib/c/generic/elf/elf_mod.c
===================================================================
--- uspace/lib/c/generic/elf/elf_mod.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/elf/elf_mod.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -44,5 +44,7 @@
  */
 
+#include <errno.h>
 #include <stdio.h>
+#include <vfs/vfs.h>
 #include <sys/types.h>
 #include <align.h>
@@ -50,9 +52,9 @@
 #include <as.h>
 #include <elf/elf.h>
-#include <unistd.h>
-#include <fcntl.h>
 #include <smc.h>
 #include <loader/pcb.h>
 #include <entry_point.h>
+#include <str_error.h>
+#include <stdlib.h>
 
 #include <elf/elf_load.h>
@@ -82,5 +84,5 @@
  * pointed to by @a info.
  *
- * @param file_name Path to the ELF file.
+ * @param file      ELF file.
  * @param so_bias   Bias to use if the file is a shared object.
  * @param info      Pointer to a structure for storing information
@@ -90,19 +92,15 @@
  *
  */
-int elf_load_file(const char *file_name, size_t so_bias, eld_flags_t flags,
-    elf_finfo_t *info)
+int elf_load_file(int file, size_t so_bias, eld_flags_t flags, elf_finfo_t *info)
 {
 	elf_ld_t elf;
 
-	int fd;
-	int rc;
-
-	fd = open(file_name, O_RDONLY);
-	if (fd < 0) {
-		DPRINTF("failed opening file\n");
-		return -1;
-	}
-
-	elf.fd = fd;
+	int ofile = vfs_clone(file, -1, true);
+	int rc = vfs_open(ofile, MODE_READ);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	elf.fd = ofile;
 	elf.info = info;
 	elf.flags = flags;
@@ -110,6 +108,14 @@
 	rc = elf_load_module(&elf, so_bias);
 
-	close(fd);
-
+	vfs_put(ofile);
+	return rc;
+}
+
+int elf_load_file_name(const char *path, size_t so_bias, eld_flags_t flags,
+    elf_finfo_t *info)
+{
+	int file = vfs_lookup(path, 0);
+	int rc = elf_load_file(file, so_bias, flags, info);
+	vfs_put(file);
 	return rc;
 }
@@ -129,7 +135,8 @@
 	elf_header_t header_buf;
 	elf_header_t *header = &header_buf;
+	aoff64_t pos = 0;
 	int i, rc;
 
-	rc = read(elf->fd, header, sizeof(elf_header_t));
+	rc = vfs_read(elf->fd, &pos, header, sizeof(elf_header_t));
 	if (rc != sizeof(elf_header_t)) {
 		DPRINTF("Read error.\n"); 
@@ -189,9 +196,6 @@
 		elf_segment_header_t segment_hdr;
 
-		/* Seek to start of segment header */
-		lseek(elf->fd, header->e_phoff
-		        + i * sizeof(elf_segment_header_t), SEEK_SET);
-
-		rc = read(elf->fd, &segment_hdr,
+		pos = header->e_phoff + i * sizeof(elf_segment_header_t);
+		rc = vfs_read(elf->fd, &pos, &segment_hdr,
 		    sizeof(elf_segment_header_t));
 		if (rc != sizeof(elf_segment_header_t)) {
@@ -211,9 +215,6 @@
 		elf_section_header_t section_hdr;
 
-		/* Seek to start of section header */
-		lseek(elf->fd, header->e_shoff
-		    + i * sizeof(elf_section_header_t), SEEK_SET);
-
-		rc = read(elf->fd, &section_hdr,
+		pos = header->e_shoff + i * sizeof(elf_section_header_t);
+		rc = vfs_read(elf->fd, &pos, &section_hdr,
 		    sizeof(elf_section_header_t));
 		if (rc != sizeof(elf_section_header_t)) {
@@ -327,4 +328,5 @@
 	uintptr_t seg_addr;
 	size_t mem_sz;
+	aoff64_t pos;
 	ssize_t rc;
 
@@ -384,34 +386,9 @@
 	 * Load segment data
 	 */
-	rc = lseek(elf->fd, entry->p_offset, SEEK_SET);
+	pos = entry->p_offset;
+	rc = vfs_read(elf->fd, &pos, seg_ptr, entry->p_filesz);
 	if (rc < 0) {
-		printf("seek error\n");
+		DPRINTF("read error\n");
 		return EE_INVALID;
-	}
-
-/*	rc = read(fd, (void *)(entry->p_vaddr + bias), entry->p_filesz);
-	if (rc < 0) { printf("read error\n"); return EE_INVALID; }*/
-
-	/* Long reads are not possible yet. Load segment piecewise. */
-
-	unsigned left, now;
-	uint8_t *dp;
-
-	left = entry->p_filesz;
-	dp = seg_ptr;
-
-	while (left > 0) {
-		now = 16384;
-		if (now > left) now = left;
-
-		rc = read(elf->fd, dp, now);
-
-		if (rc != (ssize_t) now) { 
-			DPRINTF("Read error.\n");
-			return EE_INVALID;
-		}
-
-		left -= now;
-		dp += now;
 	}
 
